various minor fixes
[distro-setup] / mail-setup
index 04e96617a20a85c64b1b550dea1e51673f13717f..c3b11d8109ea7577b1d2315f7e55104af8180bba 100755 (executable)
@@ -21,7 +21,7 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
 
 usage() {
-    cat <<EOF
+  cat <<EOF
 Usage: ${0##*/} exim4|postfix
 Setup exim4 / postfix / dovecot
 
@@ -38,7 +38,7 @@ setup.
 
 -h|--help  Print help and exit.
 EOF
-    exit $1
+  exit $1
 }
 
 type=$1
@@ -46,11 +46,11 @@ postfix() { [[ $type == postfix ]]; }
 exim() { [[ $type == exim4 ]]; }
 
 if ! exim && ! postfix; then
-    usage 1
+  usage 1
 fi
 
 if [[ ! $SUDO_USER ]]; then
-    echo "$0: error: requires running as nonroot or sudo"
+  echo "$0: error: requires running as nonroot or sudo"
 fi
 u=$SUDO_USER
 
@@ -180,23 +180,23 @@ u=$SUDO_USER
 
 
 postconfin() {
-    local MAPFILE
-    mapfile -t
-    local s
-    postconf -ev "${MAPFILE[@]}"
+  local MAPFILE
+  mapfile -t
+  local s
+  postconf -ev "${MAPFILE[@]}"
 }
 e() { printf "%s\n" "$*"; }
 pi() { # package install
-    local s f
-    if dpkg -s -- "$@" &> /dev/null; then
-        return 0;
-    fi;
-    while fuser /var/lib/dpkg/lock &>/dev/null; do sleep 1; done
-    f=/var/cache/apt/pkgcache.bin;
-    if [[ ! -r $f ]] || (( $(( $(date +%s) - $(stat -c %Y $f ) )) > 60*60*12 )); then
-        apt-get update
-    fi
-    apt-get -y install --purge --auto-remove "$@"
+  local s f
+  if dpkg -s -- "$@" &> /dev/null; then
+    return 0;
+  fi;
+  while fuser /var/lib/dpkg/lock &>/dev/null; do sleep 1; done
+  f=/var/cache/apt/pkgcache.bin;
+  if [[ ! -r $f ]] || (( $(( $(date +%s) - $(stat -c %Y $f ) )) > 60*60*12 )); then
+    apt-get update
+  fi
+  apt-get -y install --purge --auto-remove "$@"
 }
 
 postmaster=$u
@@ -215,60 +215,60 @@ smarthost="$mxhost::$mxport" # exim
 # trisquel 8 = openvpn, debian stretch = openvpn-client
 vpn_ser=openvpn-client
 if [[ ! -e /lib/systemd/system/openvpn-client@.service ]]; then
-    vpn_ser=openvpn
+  vpn_ser=openvpn
 fi
 
 if [[ $HOSTNAME == $MAIL_HOST ]]; then
-    # afaik, these will get ignored because they are routing to my own
-    # machine, but rm them is safer
-    rm -f $(eval echo ~$postmaster)/.forward /root/.forward
+  # afaik, these will get ignored because they are routing to my own
+  # machine, but rm them is safer
+  rm -f $(eval echo ~$postmaster)/.forward /root/.forward
 else
-    # this can\'t be a symlink and has permission restrictions
-    # it might work in /etc/aliases, but this seems more proper.
-    install -m 644 {-o,-g}$postmaster <(e $forward) $(eval echo ~$postmaster)/.forward
+  # this can\'t be a symlink and has permission restrictions
+  # it might work in /etc/aliases, but this seems more proper.
+  install -m 644 {-o,-g}$postmaster <(e $forward) $(eval echo ~$postmaster)/.forward
 fi
 
 # offlineimap uses this too, it is much easier to use one location than to
 # condition it\'s config and postfix\'s config
 if [[ -f /etc/fedora-release ]]; then
-    /a/exe/lnf -T ca-certificates.crt /etc/ssl/ca-bundle.trust.crt
+  /a/exe/lnf -T ca-certificates.crt /etc/ssl/ca-bundle.trust.crt
 fi
 
 if postfix; then
-    # dunno why, but debian installed postfix with builddep emacs
-    # but I will just explicitly install it here since
-    # I use it for sending mail in emacs.
-    if command -v apt-get &> /dev/null; then
-        debconf-set-selections <<EOF
+  # dunno why, but debian installed postfix with builddep emacs
+  # but I will just explicitly install it here since
+  # I use it for sending mail in emacs.
+  if command -v apt-get &> /dev/null; then
+    debconf-set-selections <<EOF
 postfix postfix/main_mailer_type select Satellite system
 postfix postfix/mailname string $HOSTNAME
 postfix postfix/relayhost string $relayhost
 postfix postfix/root_address string $postmaster
 EOF
-        if dpkg -s postfix &>/dev/null; then
-            while fuser /var/lib/dpkg/lock &>/dev/null; do sleep 1; done
-            dpkg-reconfigure -u -fnoninteractive postfix
-        else
-            pi postfix
-        fi
+    if dpkg -s postfix &>/dev/null; then
+      while fuser /var/lib/dpkg/lock &>/dev/null; do sleep 1; done
+      dpkg-reconfigure -u -fnoninteractive postfix
     else
-        source /a/bin/distro-functions/src/package-manager-abstractions
-        pi postfix
-        # Settings from reading the output when installing on debian,
-        # then seeing which were different in a default install on arch.
-        # I assume the same works for fedora.
-        postconfin <<EOF
+      pi postfix
+    fi
+  else
+    source /a/bin/distro-functions/src/package-manager-abstractions
+    pi postfix
+    # Settings from reading the output when installing on debian,
+    # then seeing which were different in a default install on arch.
+    # I assume the same works for fedora.
+    postconfin <<EOF
 mynetworks = 127.0.0.0/8 [::ffff:127.0.0.0]/104 [::1]/128
 mailbox_size_limit = 0
 relayhost = $relayhost
 inet_interfaces = loopback-only
 EOF
 
-        systemctl enable postfix
-        systemctl start postfix
-    fi
-    # i\'m assuming mail just won\'t work on systems without the sasl_passwd.
-    postconfin <<'EOF'
+    systemctl enable postfix
+    systemctl start postfix
+  fi
+  # i\'m assuming mail just won\'t work on systems without the sasl_passwd.
+  postconfin <<'EOF'
 smtp_sasl_auth_enable = yes
 smtp_sasl_password_maps = hash:/etc/postfix/sasl_passwd
 smtp_sasl_security_options = noanonymous
@@ -277,45 +277,45 @@ message_size_limit =  20480000
 smtp_tls_CAfile = /etc/ssl/certs/ca-certificates.crt
 inet_protocols = ipv4
 EOF
-    # msg_size_limit: I ran into a log file not sending cuz of size. double from 10 to 20 meg limit
-    # inet_protocols: without this, I\'ve had postfix try an ipv6 lookup then gives
-    # up and fail forever. snippet from syslog: type=AAAA: Host not found, try again
-
-
-    f=/etc/postfix/sasl_passwd
-    install -m 600 /dev/null $f
-    cat /etc/mailpass| while read -r domain port pass; do
-        # format: domain port user:pass
-        # mailpass is just a name i made up, since postfix and
-        # exim both use a slightly crazy format to translate to
-        # each other, it\'s easier to use my own format.
-        printf "[%s]:%s %s" "$domain" "$port" "${pass/@/#}" >>$f
-    done
-    postmap hash:/etc/postfix/sasl_passwd
-    # need restart instead of reload when changing
-    # inet_protocols
-    service postfix restart
+  # msg_size_limit: I ran into a log file not sending cuz of size. double from 10 to 20 meg limit
+  # inet_protocols: without this, I\'ve had postfix try an ipv6 lookup then gives
+  # up and fail forever. snippet from syslog: type=AAAA: Host not found, try again
+
+
+  f=/etc/postfix/sasl_passwd
+  install -m 600 /dev/null $f
+  cat /etc/mailpass| while read -r domain port pass; do
+    # format: domain port user:pass
+    # mailpass is just a name i made up, since postfix and
+    # exim both use a slightly crazy format to translate to
+    # each other, it\'s easier to use my own format.
+    printf "[%s]:%s %s" "$domain" "$port" "${pass/@/#}" >>$f
+  done
+  postmap hash:/etc/postfix/sasl_passwd
+  # need restart instead of reload when changing
+  # inet_protocols
+  service postfix restart
 
 else # begin exim. has debian specific stuff for now
 
-    pi openvpn
-
-    if [[ -e /p/c/filesystem ]]; then
-        # allow failure of these commands when our internet is down, they are likely not needed,
-        # we check that a valid cert is there already.
-        # to put the hostname in the known hosts
-        if ! ssh -o StrictHostKeyChecking=no root@li.iankelling.org :; then
-            openssl x509 -checkend $(( 60 * 60 * 24 * 3 )) -noout -in /etc/openvpn/mail.crt
-        else
-            # note, man openvpn implies we could just call mail-route on vpn startup/shutdown with
-            # systemd, buuut it can remake the tun device unexpectedly, i got this in the log
-            # after my internet was down for a bit:
-            # NOTE: Pulled options changed on restart, will need to close and reopen TUN/TAP device.
-            /a/exe/vpn-mk-client-cert -b mail -n mail -s /b/ds/mail-route li.iankelling.org
-        fi
+  pi openvpn
+
+  if [[ -e /p/c/filesystem ]]; then
+    # allow failure of these commands when our internet is down, they are likely not needed,
+    # we check that a valid cert is there already.
+    # to put the hostname in the known hosts
+    if ! ssh -o StrictHostKeyChecking=no root@li.iankelling.org :; then
+      openssl x509 -checkend $(( 60 * 60 * 24 * 3 )) -noout -in /etc/openvpn/mail.crt
+    else
+      # note, man openvpn implies we could just call mail-route on vpn startup/shutdown with
+      # systemd, buuut it can remake the tun device unexpectedly, i got this in the log
+      # after my internet was down for a bit:
+      # NOTE: Pulled options changed on restart, will need to close and reopen TUN/TAP device.
+      /a/exe/vpn-mk-client-cert -b mail -n mail -s /b/ds/mail-route li.iankelling.org
     fi
+  fi
 
-    cat >/etc/systemd/system/offlineimapsync.timer <<'EOF'
+  cat >/etc/systemd/system/offlineimapsync.timer <<'EOF'
 [Unit]
 Description=Run offlineimap-sync once every min
 
@@ -326,7 +326,7 @@ OnCalendar=*:0/1
 WantedBy=timers.target
 EOF
 
-    cat >/etc/systemd/system/offlineimapsync.service <<EOF
+  cat >/etc/systemd/system/offlineimapsync.service <<EOF
 [Unit]
 Description=Offlineimap sync
 After=multi-user.target
@@ -336,46 +336,46 @@ User=$u
 Type=oneshot
 ExecStart=/a/bin/log-quiet/sysd-mail-once offlineimap-sync /a/bin/distro-setup/offlineimap-sync
 EOF
-    systemctl daemon-reload
-
-    # wording of question from dpkg-reconfigure exim4-config
-    # 1. internet site; mail is sent and received directly using SMTP
-    # 2. mail sent by smarthost; received via SMTP or fetchmail
-    # 3. mail sent by smarthost; no local mail
-    # 4. local delivery only; not on a network
-    # 5. no configuration at this time
-    #
-    # Note, I have used option 2 in the past for receiving mail
-    # from lan hosts, sending external mail via another smtp server.
-    #
-    # Note, other than configtype, we could set all the options in
-    # both types of configs without harm, they would either be
-    # ignored or be disabled by other settings, but the default
-    # local_interfaces definitely makes things more secure.
-
-    # most of these settings get translated into settings
-    # in /etc/exim4/update-exim4.conf.conf
-    # how /etc/exim4/update-exim4.conf.conf translates into actual exim settings is
-    # documented in man update-exim4.conf, which outputs to the config that
-    # exim actually reads. except the man page is not perfect, for example,
-    # it doesn't document that it sets
-    # DCconfig_${dc_eximconfig_configtype}" "1"
-    # which is a line from update-exim4.conf, which is a relatively short bash script.
-    # mailname setting sets /etc/mailname
-
-    debconf-set-selections <<EOF
+  systemctl daemon-reload
+
+  # wording of question from dpkg-reconfigure exim4-config
+  # 1. internet site; mail is sent and received directly using SMTP
+  # 2. mail sent by smarthost; received via SMTP or fetchmail
+  # 3. mail sent by smarthost; no local mail
+  # 4. local delivery only; not on a network
+  # 5. no configuration at this time
+  #
+  # Note, I have used option 2 in the past for receiving mail
+  # from lan hosts, sending external mail via another smtp server.
+  #
+  # Note, other than configtype, we could set all the options in
+  # both types of configs without harm, they would either be
+  # ignored or be disabled by other settings, but the default
+  # local_interfaces definitely makes things more secure.
+
+  # most of these settings get translated into settings
+  # in /etc/exim4/update-exim4.conf.conf
+  # how /etc/exim4/update-exim4.conf.conf translates into actual exim settings is
+  # documented in man update-exim4.conf, which outputs to the config that
+  # exim actually reads. except the man page is not perfect, for example,
+  # it doesn't document that it sets
+  # DCconfig_${dc_eximconfig_configtype}" "1"
+  # which is a line from update-exim4.conf, which is a relatively short bash script.
+  # mailname setting sets /etc/mailname
+
+  debconf-set-selections <<EOF
 exim4-config exim4/use_split_config boolean true
 EOF
 
-    source /a/bin/bash_unpublished/source-semi-priv
-    exim_main_dir=/etc/exim4/conf.d/main
-    mkdir -p $exim_main_dir
+  source /a/bin/bash_unpublished/source-semi-priv
+  exim_main_dir=/etc/exim4/conf.d/main
+  mkdir -p $exim_main_dir
 
 
 
-    #### begin mail cert setup ###
-    f=/usr/local/bin/mail-cert-cron
-    cat >$f <<'EOF'
+  #### begin mail cert setup ###
+  f=/usr/local/bin/mail-cert-cron
+  cat >$f <<'EOF'
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
@@ -405,9 +405,9 @@ if [[ $new_ret != 0 ]]; then
 fi
 exit 0
 EOF
-    chmod 755 $f
+  chmod 755 $f
 
-    cat >/etc/systemd/system/mailcert.service <<'EOF'
+  cat >/etc/systemd/system/mailcert.service <<'EOF'
 [Unit]
 Description=Mail cert rsync
 After=multi-user.target
@@ -417,7 +417,7 @@ Type=oneshot
 ExecStart=/a/bin/log-quiet/sysd-mail-once mailcert /usr/local/bin/mail-cert-cron
 EOF
 
-    cat >/etc/systemd/system/mailcert.timer <<'EOF'
+  cat >/etc/systemd/system/mailcert.timer <<'EOF'
 [Unit]
 Description=Run mail-cert once a day
 
@@ -427,18 +427,18 @@ OnCalendar=daily
 [Install]
 WantedBy=timers.target
 EOF
-    systemctl daemon-reload
-    systemctl start mailcert
-    systemctl restart mailcert.timer
-    systemctl enable mailcert.timer
+  systemctl daemon-reload
+  systemctl start mailcert
+  systemctl restart mailcert.timer
+  systemctl enable mailcert.timer
 
-    ##### end mailcert setup #####
+  ##### end mailcert setup #####
 
 
 
-    if [[ $HOSTNAME == $MAIL_HOST ]]; then
+  if [[ $HOSTNAME == $MAIL_HOST ]]; then
 
-        debconf-set-selections <<EOF
+    debconf-set-selections <<EOF
 # Mail Server configuration
 # -------------------------
 
@@ -547,10 +547,10 @@ exim4-config exim4/dc_postmaster string $postmaster
 # Delivery method for local mail: 2
 exim4-config exim4/dc_localdelivery select Maildir format in home directory
 EOF
-        # MAIN_HARDCODE_PRIMARY_HOSTNAME might mess up the
-        # smarthost config type, not sure. all other settings
-        # would be unused in that config type.
-        cat >$exim_main_dir/000_localmacros <<EOF
+    # MAIN_HARDCODE_PRIMARY_HOSTNAME might mess up the
+    # smarthost config type, not sure. all other settings
+    # would be unused in that config type.
+    cat >$exim_main_dir/000_localmacros <<EOF
 # i don't have ipv6 setup for my tunnel yet.
 disable_ipv6 = true
 
@@ -609,31 +609,31 @@ DKIM_SIGN_HEADERS = mime-version:in-reply-to:references:from:date:subject:to
 EOF
 
 
-        ####### begin dovecot setup ########
-        # based on a little google and package search, just the dovecot
-        # packages we need instead of dovecot-common.
-        #
-        # dovecot-lmtpd is for exim to deliver to dovecot instead of maildir
-        # directly.  The reason to do this is to use dovecot\'s sieve, which
-        # has extensions that allow it to be almost equivalent to exim\'s
-        # filter capabilities, some ways probably better, some worse, and
-        # sieve has the benefit of being supported in postfix and
-        # proprietary/weird environments, so there is more examples on the
-        # internet. I was torn about whether to do this or not, meh.
-        pi dovecot-core dovecot-imapd dovecot-sieve dovecot-lmtpd
-
-        # if we changed 90-sieve.conf and removed the active part of the
-        # sieve option, we wouldn\'t need this, but I\'d rather not modify a
-        # default config if not needed. This won\'t work as a symlink in /a/c
-        # unfortunately.
-        sudo -u $postmaster /a/exe/lnf -T sieve/main.sieve $(eval echo ~$postmaster)/.dovecot.sieve
-
-        sed -ri -f - /etc/dovecot/conf.d/10-mail.conf <<'EOF'
+    ####### begin dovecot setup ########
+    # based on a little google and package search, just the dovecot
+    # packages we need instead of dovecot-common.
+    #
+    # dovecot-lmtpd is for exim to deliver to dovecot instead of maildir
+    # directly.  The reason to do this is to use dovecot\'s sieve, which
+    # has extensions that allow it to be almost equivalent to exim\'s
+    # filter capabilities, some ways probably better, some worse, and
+    # sieve has the benefit of being supported in postfix and
+    # proprietary/weird environments, so there is more examples on the
+    # internet. I was torn about whether to do this or not, meh.
+    pi dovecot-core dovecot-imapd dovecot-sieve dovecot-lmtpd
+
+    # if we changed 90-sieve.conf and removed the active part of the
+    # sieve option, we wouldn\'t need this, but I\'d rather not modify a
+    # default config if not needed. This won\'t work as a symlink in /a/c
+    # unfortunately.
+    sudo -u $postmaster /a/exe/lnf -T sieve/main.sieve $(eval echo ~$postmaster)/.dovecot.sieve
+
+    sed -ri -f - /etc/dovecot/conf.d/10-mail.conf <<'EOF'
 1i mail_location = maildir:/m/md:LAYOUT=fs:INBOX=/m/md/INBOX
 /^\s*mail_location\s*=/d
 EOF
 
-        cat >/etc/dovecot/conf.d/20-lmtp.conf <<EOF
+    cat >/etc/dovecot/conf.d/20-lmtp.conf <<EOF
 protocol lmtp {
 #per https://wiki2.dovecot.org/Pigeonhole/Sieve/Configuration
   mail_plugins = \$mail_plugins sieve
@@ -671,7 +671,7 @@ protocol lmtp {
 EOF
 
 
-        cat >/etc/dovecot/local.conf <<'EOF'
+    cat >/etc/dovecot/local.conf <<'EOF'
 # so I can use a different login that my shell login for mail.  this is
 # worth doing solely for the reason that if this login is compromised,
 # it won't also compromise my shell password.
@@ -693,29 +693,29 @@ ssl_prefer_server_ciphers = yes
 # auth_verbose=yes
 #mail_debug=yes
 EOF
-        ####### end dovecot setup ########
-
-
-        systemctl enable offlineimapsync.timer
-        systemctl start offlineimapsync.timer
-        systemctl restart $vpn_ser@mail
-        systemctl enable $vpn_ser@mail
-        systemctl enable dovecot
-        systemctl restart dovecot
-
-    else # $HOSTNAME != $MAIL_HOST
-        systemctl disable offlineimapsync.timer &>/dev/null ||:
-        systemctl stop offlineimapsync.timer &>/dev/null ||:
-        systemctl disable $vpn_ser@mail
-        systemctl stop $vpn_ser@mail
-        systemctl disable dovecot ||:
-        systemctl stop dovecot ||:
-        #
-        #
-        # would only exist because I wrote it i the previous condition,
-        # it\'s not part of exim
-        rm -f $exim_main_dir/000_localmacros
-        debconf-set-selections <<EOF
+    ####### end dovecot setup ########
+
+
+    systemctl enable offlineimapsync.timer
+    systemctl start offlineimapsync.timer
+    systemctl restart $vpn_ser@mail
+    systemctl enable $vpn_ser@mail
+    systemctl enable dovecot
+    systemctl restart dovecot
+
+  else # $HOSTNAME != $MAIL_HOST
+    systemctl disable offlineimapsync.timer &>/dev/null ||:
+    systemctl stop offlineimapsync.timer &>/dev/null ||:
+    systemctl disable $vpn_ser@mail
+    systemctl stop $vpn_ser@mail
+    systemctl disable dovecot ||:
+    systemctl stop dovecot ||:
+    #
+    #
+    # would only exist because I wrote it i the previous condition,
+    # it\'s not part of exim
+    rm -f $exim_main_dir/000_localmacros
+    debconf-set-selections <<EOF
 exim4-config exim4/dc_eximconfig_configtype select mail sent by smarthost; no local mail
 exim4-config exim4/dc_smarthost string $smarthost
 # the default, i think is from /etc/mailname. better to set it to
@@ -723,53 +723,53 @@ exim4-config exim4/dc_smarthost string $smarthost
 exim4-config exim4/mailname string $(hostname -f)
 EOF
 
-    fi # end $HOSTNAME != $MAIL_HOST
-
-    # if we already have it installed, need to reconfigure, without being prompted
-    if dpkg -s exim4-config &>/dev/null; then
-        # gotta remove this, otherwise the set-selections are completely
-        # ignored. It woulda been nice if this was documented somewhere!
-        rm -f /etc/exim4/update-exim4.conf.conf
-        while fuser /var/lib/dpkg/lock &>/dev/null; do sleep 1; done
-        dpkg-reconfigure -u -fnoninteractive exim4-config
-    fi
-
-    # i have the spool directory be common to distro multi-boot, so
-    # we need the uid to be the same. 608 cuz it's kind of in the middle
-    # of the free system uids.
-    IFS=:; read _ _ uid _ < <(getent passwd Debian-exim ); unset IFS
-    IFS=:; read _ _ gid _ < <(getent group Debian-exim ); unset IFS
-    if [[ ! $uid ]]; then
-        # from /var/lib/dpkg/info/exim4-base.postinst, plus uid and gid options
-       adduser --uid 608 --gid 608 --system --group --quiet --home /var/spool/exim4 \
-               --no-create-home --disabled-login --force-badname Debian-exim
-    elif [[ $uid != 608 ]]; then
-        systemctl stop exim4 ||:
-        usermod -u 608 Debian-exim
-        groupmod -g 608 Debian-exim
-        usermod -g 608 Debian-exim
-        find / /nocow -xdev -uid $uid -exec chown -h 608 {} +
-        find / /nocow -xdev -gid $gid -exec chgrp -h 608 {} +
-    fi
-
-    # light version of exim does not have sasl auth support.
-    pi exim4-daemon-heavy spamassassin
-
-
+  fi # end $HOSTNAME != $MAIL_HOST
 
-
-    ##### begin spamassassin config
-    systemctl enable spamassassin
-    # per readme.debian
-    sed -i '/^\s*CRON\s*=/d' /etc/default/spamassassin
-    e CRON=1 >>/etc/default/spamassassin
-    # just noticed this in the config file, seems like a good idea.
-    sed -i '/^\s*NICE\s*=/d' /etc/default/spamassassin
-    e 'NICE="--nicelevel 15"' >>/etc/default/spamassassin
-    systemctl start spamassassin
-    systemctl reload spamassassin
-
-    cat >/etc/systemd/system/spamddnsfix.service <<'EOF'
+  # if we already have it installed, need to reconfigure, without being prompted
+  if dpkg -s exim4-config &>/dev/null; then
+    # gotta remove this, otherwise the set-selections are completely
+    # ignored. It woulda been nice if this was documented somewhere!
+    rm -f /etc/exim4/update-exim4.conf.conf
+    while fuser /var/lib/dpkg/lock &>/dev/null; do sleep 1; done
+    dpkg-reconfigure -u -fnoninteractive exim4-config
+  fi
+
+  # i have the spool directory be common to distro multi-boot, so
+  # we need the uid to be the same. 608 cuz it's kind of in the middle
+  # of the free system uids.
+  IFS=:; read _ _ uid _ < <(getent passwd Debian-exim ); unset IFS
+  IFS=:; read _ _ gid _ < <(getent group Debian-exim ); unset IFS
+  if [[ ! $uid ]]; then
+    # from /var/lib/dpkg/info/exim4-base.postinst, plus uid and gid options
+    adduser --uid 608 --gid 608 --system --group --quiet --home /var/spool/exim4 \
+           --no-create-home --disabled-login --force-badname Debian-exim
+  elif [[ $uid != 608 ]]; then
+    systemctl stop exim4 ||:
+    usermod -u 608 Debian-exim
+    groupmod -g 608 Debian-exim
+    usermod -g 608 Debian-exim
+    find / /nocow -xdev -uid $uid -exec chown -h 608 {} +
+    find / /nocow -xdev -gid $gid -exec chgrp -h 608 {} +
+  fi
+
+  # light version of exim does not have sasl auth support.
+  pi exim4-daemon-heavy spamassassin
+
+
+
+
+  ##### begin spamassassin config
+  systemctl enable spamassassin
+  # per readme.debian
+  sed -i '/^\s*CRON\s*=/d' /etc/default/spamassassin
+  e CRON=1 >>/etc/default/spamassassin
+  # just noticed this in the config file, seems like a good idea.
+  sed -i '/^\s*NICE\s*=/d' /etc/default/spamassassin
+  e 'NICE="--nicelevel 15"' >>/etc/default/spamassassin
+  systemctl start spamassassin
+  systemctl reload spamassassin
+
+  cat >/etc/systemd/system/spamddnsfix.service <<'EOF'
 [Unit]
 Description=spamd dns bug fix cronjob
 
@@ -777,10 +777,10 @@ Description=spamd dns bug fix cronjob
 Type=oneshot
 ExecStart=/a/bin/distro-setup/spamd-dns-fix
 EOF
-    # 2017-09, debian closed the bug on this saying upstream had fixed it.
-    # remove this when i\'m using the newer package, ie, debian 10, or maybe
-    # ubuntu 18.04.
-    cat >/etc/systemd/system/spamddnsfix.timer <<'EOF'
+  # 2017-09, debian closed the bug on this saying upstream had fixed it.
+  # remove this when i\'m using the newer package, ie, debian 10, or maybe
+  # ubuntu 18.04.
+  cat >/etc/systemd/system/spamddnsfix.timer <<'EOF'
 [Unit]
 Description=run spamd bug fix script every 10 minutes
 
@@ -794,17 +794,17 @@ OnUnitActiveSec=550
 [Install]
 WantedBy=timers.target
 EOF
-    systemctl daemon-reload
-    systemctl restart spamddnsfix.timer
-    systemctl enable spamddnsfix.timer
-    #
-    #####   end spamassassin config
+  systemctl daemon-reload
+  systemctl restart spamddnsfix.timer
+  systemctl enable spamddnsfix.timer
+  #
+  #####   end spamassassin config
 
 
 
 
 
-    cat >/etc/exim4/rcpt_local_acl <<'EOF'
+  cat >/etc/exim4/rcpt_local_acl <<'EOF'
 # Only hosts we control send to mail.iankelling.org, so make sure
 # they are all authed.
 # Note, if we wanted authed senders for all domains,
@@ -814,7 +814,7 @@ deny
   !authenticated = *
   domains = mail.iankelling.org
 EOF
-    cat >/etc/exim4/data_local_acl <<'EOF'
+  cat >/etc/exim4/data_local_acl <<'EOF'
 # Except for the "condition =", this was
 # a comment in the check_data acl. The comment about this not
 # being suitable is mostly bs. The only thing related I found was to
@@ -833,7 +833,7 @@ EOF
               X-Spam_report: $spam_report
 
 EOF
-    cat >/etc/exim4/conf.d/auth/29_exim4-config_auth <<'EOF'
+  cat >/etc/exim4/conf.d/auth/29_exim4-config_auth <<'EOF'
 # from 30_exim4-config_examples
 
 plain_server:
@@ -847,7 +847,7 @@ server_advertise_condition = ${if eq{$tls_in_cipher}{}{}{*}}
 .endif
 EOF
 
-    cat >/etc/exim4/conf.d/router/900_exim4-config_local_user <<'EOF'
+  cat >/etc/exim4/conf.d/router/900_exim4-config_local_user <<'EOF'
 ### router/900_exim4-config_local_user
 #################################
 
@@ -865,7 +865,7 @@ local_user:
   transport = LOCAL_DELIVERY
   cannot_route_message = Unknown user
 EOF
-    cat >/etc/exim4/conf.d/transport/30_exim4-config_dovecot_lmtp <<'EOF'
+  cat >/etc/exim4/conf.d/transport/30_exim4-config_dovecot_lmtp <<'EOF'
 dovecot_lmtp:
         driver = lmtp
         socket = /var/run/dovecot/lmtp
@@ -873,7 +873,7 @@ dovecot_lmtp:
         batch_max = 200
 EOF
 
-    cat >/etc/exim4/conf.d/router/190_exim4-config_fsfsmarthost <<'EOF'
+  cat >/etc/exim4/conf.d/router/190_exim4-config_fsfsmarthost <<'EOF'
 # smarthost for fsf mail
 # ian: copied from /etc/exim4/conf.d/router/200_exim4-config_primary, and added senders = and
 # replaced DCsmarthost with mail.fsf.org
@@ -889,85 +889,85 @@ fsfsmarthost:
   no_more
 EOF
 
-    # https://blog.dhampir.no/content/make-exim4-on-debian-respect-forward-and-etcaliases-when-using-a-smarthost
-    # i only need .forwards, so just doing that one.
-    cd /etc/exim4/conf.d/router
-    b=userforward_higher_priority
-    # replace the router name so it is unique
-    sed -r s/^\\S+:/$b:/ 600_exim4-config_userforward >175_$b
-
-    # begin setup passwd.client
-    f=/etc/exim4/passwd.client
-    rm -f /etc/exim4/passwd.client
-    install -m 640 -g Debian-exim /dev/null $f
-    cat /etc/mailpass| while read -r domain port pass; do
-        # reference: exim4_passwd_client(5)
-        printf "%s:%s\n" "$domain" "$pass" >>$f
-    done
-    # end setup passwd.client
-
-    # by default, only 10 days of logs are kept. increase that.
-    sed -ri 's/^(\s*rotate\s).*/\11000/' /etc/logrotate.d/exim4-base
-
-    systemctl restart exim4
-
-        fi  #### end if exim4
-
-         # /etc/alias setup is debian specific, and
-         # exim config sets up an /etc/alias from root to the postmaster, which i
-         # config to ian, as long as there exists an entry for root, or there was
-         # no preexisting aliases file. based on the postinst file. postfix
-         # won\'t set up a root to $postmaster alias if it\'s already installed.
-         # Since postfix is not the greatest, just set it ourselves.
-         if [[ $postmaster != root ]]; then
-             sed -i --follow-symlinks -f - /etc/aliases <<EOF
+  # https://blog.dhampir.no/content/make-exim4-on-debian-respect-forward-and-etcaliases-when-using-a-smarthost
+  # i only need .forwards, so just doing that one.
+  cd /etc/exim4/conf.d/router
+  b=userforward_higher_priority
+  # replace the router name so it is unique
+  sed -r s/^\\S+:/$b:/ 600_exim4-config_userforward >175_$b
+
+  # begin setup passwd.client
+  f=/etc/exim4/passwd.client
+  rm -f /etc/exim4/passwd.client
+  install -m 640 -g Debian-exim /dev/null $f
+  cat /etc/mailpass| while read -r domain port pass; do
+    # reference: exim4_passwd_client(5)
+    printf "%s:%s\n" "$domain" "$pass" >>$f
+  done
+  # end setup passwd.client
+
+  # by default, only 10 days of logs are kept. increase that.
+  sed -ri 's/^(\s*rotate\s).*/\11000/' /etc/logrotate.d/exim4-base
+
+  systemctl restart exim4
+
+fi  #### end if exim4
+
+# /etc/alias setup is debian specific, and
+# exim config sets up an /etc/alias from root to the postmaster, which i
+# config to ian, as long as there exists an entry for root, or there was
+# no preexisting aliases file. based on the postinst file. postfix
+# won\'t set up a root to $postmaster alias if it\'s already installed.
+# Since postfix is not the greatest, just set it ourselves.
+if [[ $postmaster != root ]]; then
+  sed -i --follow-symlinks -f - /etc/aliases <<EOF
 \$a root: $postmaster
 /^root:/d
 EOF
-             newaliases
-         fi
-
-         # put spool dir in directory that spans multiple distros.
-         # based on http://www.postfix.org/qmgr.8.html and my notes in gnus
-         #
-         # todo: I\'m suspicious of uids for Debian-exim being the same across
-         # distros. It would be good to test this.
-         dir=/nocow/$type
-         sdir=/var/spool/$type
-         # we only do this if our system has $dir
-         if [[ -e /nocow && $(readlink -f $sdir) != $dir ]]; then
-             systemctl stop $type
-             if [[ ! -e $dir && -d $sdir ]]; then
-                 mv $sdir $dir
-             fi
-             /a/exe/lnf -T $dir $sdir
-         fi
-
-         systemctl restart $type
-         systemctl enable $type
-
-         # MAIL_HOST also does radicale, and easier to start and stop it here
-         # for when MAIL_HOST changes, so radicale gets the synced files and
-         # does not stop us from remounting /o.
-         if dpkg -s radicale &>/dev/null; then
-             if [[ $HOSTNAME == $MAIL_HOST ]]; then
-                 systemctl restart radicale
-                 systemctl enable radicale
-                 if [[ -e /etc/logrotate.d/radicale.disabled ]]; then
-                     mv /etc/logrotate.d/radicale{.disabled,}
-                 fi
-             else
-                 systemctl stop radicale
-                 systemctl disable radicale
-        # weekly logrotate tries to restart radicale even if it's a disabled service in flidas.
-        if [[ -e /etc/logrotate.d/radicale ]]; then
-            mv /etc/logrotate.d/radicale{,.disabled}
-        fi
-        fi
-        fi
-         exit 0
-
-         # if I wanted the from address to be renamed and sent to a different address,
-         # echo "sdx@localhost development@localhost" | sudo dd of=/etc/postfix/recipient_canonical
-         # sudo postmap hash:/etc/postfix/recipient_canonical
-         # sudo service postfix reload
+  newaliases
+fi
+
+# put spool dir in directory that spans multiple distros.
+# based on http://www.postfix.org/qmgr.8.html and my notes in gnus
+#
+# todo: I\'m suspicious of uids for Debian-exim being the same across
+# distros. It would be good to test this.
+dir=/nocow/$type
+sdir=/var/spool/$type
+# we only do this if our system has $dir
+if [[ -e /nocow && $(readlink -f $sdir) != $dir ]]; then
+  systemctl stop $type
+  if [[ ! -e $dir && -d $sdir ]]; then
+    mv $sdir $dir
+  fi
+  /a/exe/lnf -T $dir $sdir
+fi
+
+systemctl restart $type
+systemctl enable $type
+
+# MAIL_HOST also does radicale, and easier to start and stop it here
+# for when MAIL_HOST changes, so radicale gets the synced files and
+# does not stop us from remounting /o.
+if dpkg -s radicale &>/dev/null; then
+  if [[ $HOSTNAME == $MAIL_HOST ]]; then
+    systemctl restart radicale
+    systemctl enable radicale
+    if [[ -e /etc/logrotate.d/radicale.disabled ]]; then
+      mv /etc/logrotate.d/radicale{.disabled,}
+    fi
+  else
+    systemctl stop radicale
+    systemctl disable radicale
+    # weekly logrotate tries to restart radicale even if it's a disabled service in flidas.
+    if [[ -e /etc/logrotate.d/radicale ]]; then
+      mv /etc/logrotate.d/radicale{,.disabled}
+    fi
+  fi
+fi
+exit 0
+:
+# if I wanted the from address to be renamed and sent to a different address,
+# echo "sdx@localhost development@localhost" | sudo dd of=/etc/postfix/recipient_canonical
+# sudo postmap hash:/etc/postfix/recipient_canonical
+# sudo service postfix reload